;~@sa1 <-- DO NOT REMOVE THIS LINE!
;==========================================
;; SMB2 Course Clear Door
;==========================================
	EnterTile		= $25
;==========================================
;; Init and Main JSL
;==========================================
	print "INIT ",pc
	LDA $13
	EOR $748B
	STA $748B
	JSL $01ACF9
	LDA $400083,x
	STA $00
	TXY
	LDX #$15
-	CPX $75E9
	BEQ +
	LDA $3200,x
	CMP $3200,y
	BNE +
	LDA $400083,x
	CMP $00
	BNE +
	TDC
	STA $3242,y
	TYX
	RTL
+	DEX
	BPL -
	TYX
	LDA #$1C
	STA $750A,x
	RTL
	print "MAIN ",pc
	PHB
	PHK
	PLB
	JSR Main
	PLB
	RTL
;==========================================
;; Main Code
;==========================================
Main:	LDY #$15
-	LDA $3242,y
	CMP #$08
	BCC +
	LDA $762C,y
	AND #$20
	BEQ .Return
+	DEY
	BPL -
	LDA #$18
	STA $6F30
	LDA $D8,x
	ASL A
	AND #$0E
	TAY
	REP #$20
	LDA .Gfx,y
	PHA
	LDA .Ptr,y
	LDY $9D
	BNE +
	PHA
+	SEP #$20
.Return	RTS
.Gfx	dw SubGfx-$01,SubGfx2-$01,SubGfx2-$01
.Ptr	dw .0-$01,.1-$01,.2-$01,.3-$01,.Return-$01
.0	LDA $750A,x
	BEQ +
	CMP #$1C
	BNE ++
	LDA #$2D
	STA $7DFB
++	DEC $750A,x
	RTS
+	INC $D8,x
.1	JSL $01A7DC
	BCC +
	LDA $16
	AND #$08
	BEQ +
	INC $D8,x
	LDA #$20
	STA $32C6,x
+	RTS
.2	LDY.b #EnterTile
	LDA $322C,x
	STA $94
	STZ $7D
	LDA $32C6,x
	BNE +
	LDA #$FF
	STA $7493
	STA $73C6
	LDA #$03
	STA $7DFB
	LDY #$40
	STY $7495
	INC $D8,x
+	STY $73E0
	RTS
.3	LDA #$40
	STA $73E0
	RTS

SubGfx:	JSR GetDrawInfo
	LDA $750A,x
	LSR A
	AND #$0C
	EOR #$0C
	LSR A
	ORA #$60
	STA $02
	LDX #01
.Loop	LDA $00
	STA $6300,y
	LDA $01
	CLC
	ADC .YDisp,x
	STA $6301,y
	LDA $02
	STA $6302,y
	LDA $64
	ORA .Prop,x
	STA $6303,y
	INY #4
	DEX
	BPL .Loop
	LDX $75E9
	LDY #$02
	LDA #$01
	JSL $01B7B3
	RTS
.YDisp	db $EF,$FF
.Prop	db $00,$80
SubGfx2:	JSR GetDrawInfo
	LDA $322C,x
	STA $0A
	LDA $326E,x
	STA $0B
	LDA $3216,x
	STA $0C
;	LDA $3258,x
;	STA $0D
	LDA $14
	LSR A
	AND #$0C
	STA $0E
	LDA $14
	LSR A
	LDA #$40
	BCC +
	TDC
+	ORA $33B8,x
	ORA $64
	STA $0F
	ROL #2
	AND #$02
	TAX
	REP #$20
	LDA .TilePtr,x
	STA $06
	SEP #$20
	TYX
	LDY #$04
.Loop	LDA $00
	CLC
	ADC .XDisp,y
	STA $6300,x
	LDA $01
	CLC
	ADC .YDisp,y
	STA $6301,x
	CPY #$02
	BCS +
	STZ $6302,x
	BRA ++
+	LDA ($06),y
	STA $6302,x
++	LDA $0F
	STA $6303,x
	INX #4
	DEY
	BPL .Loop
	LDX #$00
	LDY #$04
-	LDA #$F0
	CMP $6201,x
	BNE .Next
	REP #$21
	LDA $94
	ADC #$0010
	SEC
	SBC $0A
	CMP #$0040
	SEP #$20
	BCS .Next
	LDA $0C
	ADC .YDisp,y
	SEC
	SBC $1C
	STA $6201,x
	LDA $0A
	SEC
	SBC $1A
	CLC
	ADC .XDisp,y
	STA $6200,x
	LDA ($06),y
	STA $6202,x
	LDA $0F
	STA $6203,x
	PHX
	TXA
	LSR #2
	TAX
	LDA $03
	AND #$01
	ORA #$02
	STA $6420,x
	PLX
.Next	INX #4
	DEY
	BPL -
	LDX $75E9
	LDY #$02
	LDA #$04
	JSL $01B7B3
	RTS
.XDisp	db $00,$00,$10,$10,$20
.YDisp	db $EF,$FF,$EF,$FF,$FF
.Tile1	db $EC,$EC,$CE,$EC,$CE
.Tile2	db $EC,$EC,$EE,$EC,$EE
.TilePtr	dw .Tile1,.Tile2
;
GetDrawInfo:	LDA $326E,x
		XBA
		LDA $322C,x
		REP #$20
		SEC
		SBC $1A
		STA $00
		CLC
		ADC.w #$0040
		CMP.w #$0180
		SEP #$20
		LDA $01
		BEQ +
		LDA #$01
+		STA $3376,x
		TDC
		ROL A
		STA $7536,x
		BNE .Invalid
		LDA $3258,x
		XBA
		LDA $75EA,x
		AND #$20
		BEQ .CheckOnce
.CheckTwice	LDA $3216,x
		REP #$21
		ADC.w #$001C
		SEC
		SBC $1C
		SEP #$20
		LDA $3258,x
		XBA
		BEQ .CheckOnce
		LDA #$02
.CheckOnce	STA $7642,x
		LDA $3216,x
		REP #$21
		ADC.w #$000C
		SEC
		SBC $1C
		SEP #$21
		SBC #$0C
		STA $01
		XBA
		BEQ .OnScreenY
		INC $7642,x
.OnScreenY	LDY $33A2,x
		RTS
		
.Invalid	PLA
	PLA
	RTS